> For the complete documentation index, see [llms.txt](https://docs.b2ihealthcare.com/snow-owl-authoring-platform/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.b2ihealthcare.com/snow-owl-authoring-platform/snomed-ct-templates/concept-creation-by-templates/bulk-concept-creation.md).

# Bulk Concept Creation

First, you have to choose a template in order to bulk create specific concepts. Navigate to the main toolbar and select `File > New… > Concepts from template (bulk)` and hit **`Next`**.

![SNOMED CT concepts from template](https://snowowl.atlassian.net/wiki/download/thumbnails/775585870/05.png?version=1\&modificationDate=1605264785313\&cacheVersion=1\&api=v2\&width=400)

On the following page of the wizard dialog, you can choose from the pre-imported templates (all currently existing [SNOMED International templates](https://github.com/IHTSDO/snomed-templates) are available), which will determine the concepts to be created.

![List of available templates](https://snowowl.atlassian.net/wiki/download/thumbnails/775585870/06.png?version=1\&modificationDate=1605265038583\&cacheVersion=1\&api=v2\&width=400)

Now you can choose the bulk input file which must contain values for all slots present in the selected template definition. For example, the template called "*Congenital \[morphology] of \[body structure] (disorder)*" has the following template definition (written in [Expression Template Language v1.0](https://confluence.ihtsdotools.org/display/DOCSTS/6.1.+Expression+Template+Language)):

```
64572001 |Disease (disorder)|:
 {
  246454002 |Occurrence (attribute)| = 255399007 |Congenital (qualifier value)|,
  116676008 |Associated morphology (attribute)| = [[+id(<< 49755003 |Morphologically abnormal structure (morphologic abnormality)|) @morphology]],
  363698007 |Finding site (attribute)| = [[+id(<<442083009 |Anatomical or acquired body structure (body structure)|) @findingSite]]
 }
```

For this template, one must create a tab or comma-separated input file with the following two columns: *morphology*, *findingSite*. Then each individual row must represent a potential concept replacement value.

![Example bulk input format](/files/-MWZR0M4CDXdSHDDqjku)

![Select input file](https://snowowl.atlassian.net/wiki/download/thumbnails/775585870/08.png?version=1\&modificationDate=1605265815404\&cacheVersion=1\&api=v2\&width=400)

If the template definition selected is valid, syntactically correct and the format of the bulk input file is in correspondence with the template, the bulk creation of concepts starts after hitting **`Next`**. When the process finished, a wizard dialog can be opened by double-clicking on the finished remote job, which will display all the concepts with their IDs and FSNs that have been newly created and added to SNOMED CT.

![List of newly created concepts](https://snowowl.atlassian.net/wiki/download/thumbnails/775585870/09.png?version=1\&modificationDate=1605266074091\&cacheVersion=1\&api=v2\&width=400)

Created concepts can be opened from the task **Review Changes Tab.**


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.b2ihealthcare.com/snow-owl-authoring-platform/snomed-ct-templates/concept-creation-by-templates/bulk-concept-creation.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
